{
    "$graph": [
        {
            "class": "ExpressionTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "doc": "This tool groups waltz qc files into a single directory\n",
            "inputs": [
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/all_fp_results"
                },
                {
                    "type": "File",
                    "id": "#group_qc_files.cwl/combined_qc"
                },
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/duplex_aggregate_bam_metrics_pool_a"
                },
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/duplex_aggregate_bam_metrics_pool_b"
                },
                {
                    "type": "File",
                    "id": "#group_qc_files.cwl/family_sizes"
                },
                {
                    "type": "File",
                    "id": "#group_qc_files.cwl/family_types_A"
                },
                {
                    "type": "File",
                    "id": "#group_qc_files.cwl/family_types_B"
                },
                {
                    "type": "File",
                    "id": "#group_qc_files.cwl/gender_table"
                },
                {
                    "type": "File",
                    "id": "#group_qc_files.cwl/noise_alt_percent"
                },
                {
                    "type": "File",
                    "id": "#group_qc_files.cwl/noise_contributing_sites"
                },
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/simplex_aggregate_bam_metrics_pool_a"
                },
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/simplex_aggregate_bam_metrics_pool_b"
                },
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/standard_aggregate_bam_metrics_pool_a"
                },
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/standard_aggregate_bam_metrics_pool_b"
                },
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/unfiltered_aggregate_bam_metrics_pool_a"
                },
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/unfiltered_aggregate_bam_metrics_pool_b"
                }
            ],
            "expression": "${\n  var output_files = [];\n\n  output_files.push(inputs.standard_aggregate_bam_metrics_pool_a);\n  output_files.push(inputs.unfiltered_aggregate_bam_metrics_pool_a);\n  output_files.push(inputs.simplex_aggregate_bam_metrics_pool_a);\n  output_files.push(inputs.duplex_aggregate_bam_metrics_pool_a);\n  output_files.push(inputs.standard_aggregate_bam_metrics_pool_b);\n  output_files.push(inputs.unfiltered_aggregate_bam_metrics_pool_b);\n  output_files.push(inputs.simplex_aggregate_bam_metrics_pool_b);\n  output_files.push(inputs.duplex_aggregate_bam_metrics_pool_b);\n  output_files.push(inputs.all_fp_results);\n  output_files.push(inputs.gender_table);\n  output_files.push(inputs.noise_alt_percent);\n  output_files.push(inputs.noise_contributing_sites);\n  output_files.push(inputs.family_sizes);\n  output_files.push(inputs.family_types_A);\n  output_files.push(inputs.family_types_B);\n  output_files.push(inputs.combined_qc);\n\n  return {\n    'qc_files': {\n      'class': 'Directory',\n      'basename': 'QC_Results',\n      'listing': output_files\n    }\n  };\n}",
            "id": "#group_qc_files.cwl",
            "outputs": [
                {
                    "type": "Directory",
                    "id": "#group_qc_files.cwl/qc_files"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "calculate_noise.sh"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#calculate_noise.cwl/good_positions_A"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#calculate_noise.cwl/waltz_directory"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$('noise.txt')"
                    },
                    "id": "#calculate_noise.cwl/noise"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$('noise-by-substitution.txt')"
                    },
                    "id": "#calculate_noise.cwl/noise_by_substitution"
                }
            ],
            "id": "#calculate_noise.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "plot_noise"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--noise_file"
                    },
                    "id": "#plot_noise.cwl/noise"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--noise_by_substitution"
                    },
                    "id": "#plot_noise.cwl/noise_by_substitution"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--title_file"
                    },
                    "id": "#plot_noise.cwl/title_file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$('NoiseAltPercent.pdf')"
                    },
                    "id": "#plot_noise.cwl/noise_alt_percent"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$('NoiseContributingSites.pdf')"
                    },
                    "id": "#plot_noise.cwl/noise_contributing_sites"
                }
            ],
            "id": "#plot_noise.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000,
                    "coresMin": 1
                }
            ],
            "baseCommand": [
                "aggregate_bam_metrics.sh"
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#aggregate_bam_metrics.cwl/output_dir_name"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#aggregate_bam_metrics.cwl/waltz_input_files"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": ".",
                        "outputEval": "${\n  self[0].basename = inputs.output_dir_name;\n  return self[0]\n}\n"
                    },
                    "id": "#aggregate_bam_metrics.cwl/output_dir"
                }
            ],
            "id": "#aggregate_bam_metrics.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "combine_qc_pdfs"
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#combine_qc_pdfs.cwl/align_rate"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 8
                    },
                    "id": "#combine_qc_pdfs.cwl/coverage_per_interval"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 10
                    },
                    "id": "#combine_qc_pdfs.cwl/family_sizes_all"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 12
                    },
                    "id": "#combine_qc_pdfs.cwl/family_sizes_duplex"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 11
                    },
                    "id": "#combine_qc_pdfs.cwl/family_sizes_simplex"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 9
                    },
                    "id": "#combine_qc_pdfs.cwl/family_types"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 15
                    },
                    "id": "#combine_qc_pdfs.cwl/fingerprinting_qc"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 6
                    },
                    "id": "#combine_qc_pdfs.cwl/gc_cov_each_sample"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 16
                    },
                    "id": "#combine_qc_pdfs.cwl/gender_check"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 7
                    },
                    "id": "#combine_qc_pdfs.cwl/insert_sizes"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 5
                    },
                    "id": "#combine_qc_pdfs.cwl/mean_cov"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 13
                    },
                    "id": "#combine_qc_pdfs.cwl/noise_alt_percent"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 14
                    },
                    "id": "#combine_qc_pdfs.cwl/noise_contributing_sites"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 4
                    },
                    "id": "#combine_qc_pdfs.cwl/on_target_rate"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 17
                    },
                    "id": "#combine_qc_pdfs.cwl/pipeline_inputs"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#combine_qc_pdfs.cwl/read_counts"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-t"
                    },
                    "id": "#combine_qc_pdfs.cwl/title_file"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#combine_qc_pdfs.cwl/title_page"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.pdf"
                    },
                    "id": "#combine_qc_pdfs.cwl/combined_qc"
                }
            ],
            "id": "#combine_qc_pdfs.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "fingerprinting"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--fp_config"
                    },
                    "id": "#fingerprinting.cwl/FP_config_file"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--output_dir"
                    },
                    "id": "#fingerprinting.cwl/output_directory"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--title_file"
                    },
                    "id": "#fingerprinting.cwl/title_file"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--waltz_dir_A"
                    },
                    "id": "#fingerprinting.cwl/waltz_directory_A"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--waltz_dir_A_duplex"
                    },
                    "id": "#fingerprinting.cwl/waltz_directory_A_duplex"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--waltz_dir_B"
                    },
                    "id": "#fingerprinting.cwl/waltz_directory_B"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "--waltz_dir_B_duplex"
                    },
                    "id": "#fingerprinting.cwl/waltz_directory_B_duplex"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$('./FPResults/FPFigures.pdf')"
                    },
                    "id": "#fingerprinting.cwl/FPFigures"
                },
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$('./FPResults')"
                    },
                    "id": "#fingerprinting.cwl/all_fp_results"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$('GenderMisMatch.pdf')"
                    },
                    "id": "#fingerprinting.cwl/gender_plot"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$('MisMatchedGender.txt')"
                    },
                    "id": "#fingerprinting.cwl/gender_table"
                }
            ],
            "id": "#fingerprinting.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000,
                    "coresMin": 1
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.family_sizes)"
                        },
                        {
                            "entry": "$(inputs.family_types_A)"
                        },
                        {
                            "entry": "$(inputs.family_types_B)"
                        }
                    ]
                }
            ],
            "baseCommand": "qc_wrapper",
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-mda"
                    },
                    "id": "#innovation_qc.cwl/duplex_waltz_metrics_pool_a"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-mdb"
                    },
                    "id": "#innovation_qc.cwl/duplex_waltz_metrics_pool_b"
                },
                {
                    "type": "File",
                    "id": "#innovation_qc.cwl/family_sizes"
                },
                {
                    "type": "File",
                    "id": "#innovation_qc.cwl/family_types_A"
                },
                {
                    "type": "File",
                    "id": "#innovation_qc.cwl/family_types_B"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-y"
                    },
                    "id": "#innovation_qc.cwl/inputs_yaml"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-msa"
                    },
                    "id": "#innovation_qc.cwl/simplex_waltz_metrics_pool_a"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-msb"
                    },
                    "id": "#innovation_qc.cwl/simplex_waltz_metrics_pool_b"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-swa"
                    },
                    "id": "#innovation_qc.cwl/standard_waltz_metrics_pool_a"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-swb"
                    },
                    "id": "#innovation_qc.cwl/standard_waltz_metrics_pool_b"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-t"
                    },
                    "id": "#innovation_qc.cwl/title_file"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-mua"
                    },
                    "id": "#innovation_qc.cwl/unfiltered_waltz_metrics_pool_a"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-mub"
                    },
                    "id": "#innovation_qc.cwl/unfiltered_waltz_metrics_pool_b"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "align_rate.pdf"
                    },
                    "id": "#innovation_qc.cwl/align_rate"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "coverage_per_interval.pdf"
                    },
                    "id": "#innovation_qc.cwl/coverage_per_interval"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "family_sizes_all.pdf"
                    },
                    "id": "#innovation_qc.cwl/family_sizes_all"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "family_sizes_duplex.pdf"
                    },
                    "id": "#innovation_qc.cwl/family_sizes_duplex"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "family_sizes_simplex.pdf"
                    },
                    "id": "#innovation_qc.cwl/family_sizes_simplex"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "family_types.pdf"
                    },
                    "id": "#innovation_qc.cwl/family_types"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "gc_cov_each_sample.pdf"
                    },
                    "id": "#innovation_qc.cwl/gc_cov_each_sample"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "insert_sizes.pdf"
                    },
                    "id": "#innovation_qc.cwl/insert_sizes"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "mean_cov.pdf"
                    },
                    "id": "#innovation_qc.cwl/mean_cov"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "on_target_rate.pdf"
                    },
                    "id": "#innovation_qc.cwl/on_target_rate"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "pipeline_inputs.pdf"
                    },
                    "id": "#innovation_qc.cwl/pipeline_inputs"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "read_counts.pdf"
                    },
                    "id": "#innovation_qc.cwl/read_counts"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "title_page.pdf"
                    },
                    "id": "#innovation_qc.cwl/title_page"
                }
            ],
            "id": "#innovation_qc.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "make_umi_qc_tables.sh"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#make_umi_qc_tables.cwl/A_on_target_positions"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#make_umi_qc_tables.cwl/B_on_target_positions"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#make_umi_qc_tables.cwl/folders"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "family-sizes.txt"
                    },
                    "id": "#make_umi_qc_tables.cwl/family_sizes"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "family-types-A.txt"
                    },
                    "id": "#make_umi_qc_tables.cwl/family_types_A"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "family-types-B.txt"
                    },
                    "id": "#make_umi_qc_tables.cwl/family_types_B"
                }
            ],
            "id": "#make_umi_qc_tables.cwl"
        },
        {
            "class": "Workflow",
            "doc": "This workflow is intended to be used to test the QC module,\nwithout having to run the long waltz step\n",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#main/A_on_target_positions"
                },
                {
                    "type": "File",
                    "id": "#main/B_on_target_positions"
                },
                {
                    "type": "File",
                    "id": "#main/FP_config_file"
                },
                {
                    "type": "File",
                    "id": "#main/inputs_yaml"
                },
                {
                    "type": "File",
                    "id": "#main/noise__good_positions_A"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "id": "#main/sample_directories"
                },
                {
                    "type": "File",
                    "id": "#main/title_file"
                },
                {
                    "type": "Directory",
                    "id": "#main/waltz_duplex_pool_a"
                },
                {
                    "type": "Directory",
                    "id": "#main/waltz_duplex_pool_b"
                },
                {
                    "type": "Directory",
                    "id": "#main/waltz_simplex_pool_a"
                },
                {
                    "type": "Directory",
                    "id": "#main/waltz_simplex_pool_b"
                },
                {
                    "type": "Directory",
                    "id": "#main/waltz_standard_pool_a"
                },
                {
                    "type": "Directory",
                    "id": "#main/waltz_standard_pool_b"
                },
                {
                    "type": "Directory",
                    "id": "#main/waltz_unfiltered_pool_a"
                },
                {
                    "type": "Directory",
                    "id": "#main/waltz_unfiltered_pool_b"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputSource": "#main/group_qc_files/qc_files",
                    "id": "#main/combined_qc"
                }
            ],
            "steps": [
                {
                    "run": "#combine_qc_pdfs.cwl",
                    "in": [
                        {
                            "source": "#main/innovation_qc/align_rate",
                            "id": "#main/combine_qc/align_rate"
                        },
                        {
                            "source": "#main/innovation_qc/coverage_per_interval",
                            "id": "#main/combine_qc/coverage_per_interval"
                        },
                        {
                            "source": "#main/innovation_qc/family_sizes_all",
                            "id": "#main/combine_qc/family_sizes_all"
                        },
                        {
                            "source": "#main/innovation_qc/family_sizes_duplex",
                            "id": "#main/combine_qc/family_sizes_duplex"
                        },
                        {
                            "source": "#main/innovation_qc/family_sizes_simplex",
                            "id": "#main/combine_qc/family_sizes_simplex"
                        },
                        {
                            "source": "#main/innovation_qc/family_types",
                            "id": "#main/combine_qc/family_types"
                        },
                        {
                            "source": "#main/fingerprinting/FPFigures",
                            "id": "#main/combine_qc/fingerprinting_qc"
                        },
                        {
                            "source": "#main/innovation_qc/gc_cov_each_sample",
                            "id": "#main/combine_qc/gc_cov_each_sample"
                        },
                        {
                            "source": "#main/fingerprinting/gender_plot",
                            "id": "#main/combine_qc/gender_check"
                        },
                        {
                            "source": "#main/innovation_qc/insert_sizes",
                            "id": "#main/combine_qc/insert_sizes"
                        },
                        {
                            "source": "#main/innovation_qc/mean_cov",
                            "id": "#main/combine_qc/mean_cov"
                        },
                        {
                            "source": "#main/noise_plots/noise_alt_percent",
                            "id": "#main/combine_qc/noise_alt_percent"
                        },
                        {
                            "source": "#main/noise_plots/noise_contributing_sites",
                            "id": "#main/combine_qc/noise_contributing_sites"
                        },
                        {
                            "source": "#main/innovation_qc/on_target_rate",
                            "id": "#main/combine_qc/on_target_rate"
                        },
                        {
                            "source": "#main/innovation_qc/pipeline_inputs",
                            "id": "#main/combine_qc/pipeline_inputs"
                        },
                        {
                            "source": "#main/innovation_qc/read_counts",
                            "id": "#main/combine_qc/read_counts"
                        },
                        {
                            "source": "#main/title_file",
                            "id": "#main/combine_qc/title_file"
                        },
                        {
                            "source": "#main/innovation_qc/title_page",
                            "id": "#main/combine_qc/title_page"
                        }
                    ],
                    "out": [
                        "#main/combine_qc/combined_qc"
                    ],
                    "id": "#main/combine_qc"
                },
                {
                    "run": "#aggregate_bam_metrics.cwl",
                    "in": [
                        {
                            "valueFrom": "$('waltz_duplex_pool_a')",
                            "id": "#main/duplex_aggregate_bam_metrics_pool_a/output_dir_name"
                        },
                        {
                            "source": "#main/waltz_duplex_pool_a",
                            "id": "#main/duplex_aggregate_bam_metrics_pool_a/waltz_input_files"
                        }
                    ],
                    "out": [
                        "#main/duplex_aggregate_bam_metrics_pool_a/output_dir"
                    ],
                    "id": "#main/duplex_aggregate_bam_metrics_pool_a"
                },
                {
                    "run": "#aggregate_bam_metrics.cwl",
                    "in": [
                        {
                            "valueFrom": "$('waltz_duplex_pool_b')",
                            "id": "#main/duplex_aggregate_bam_metrics_pool_b/output_dir_name"
                        },
                        {
                            "source": "#main/waltz_duplex_pool_b",
                            "id": "#main/duplex_aggregate_bam_metrics_pool_b/waltz_input_files"
                        }
                    ],
                    "out": [
                        "#main/duplex_aggregate_bam_metrics_pool_b/output_dir"
                    ],
                    "id": "#main/duplex_aggregate_bam_metrics_pool_b"
                },
                {
                    "run": "#fingerprinting.cwl",
                    "in": [
                        {
                            "source": "#main/FP_config_file",
                            "id": "#main/fingerprinting/FP_config_file"
                        },
                        {
                            "valueFrom": "${return '.'}",
                            "id": "#main/fingerprinting/output_directory"
                        },
                        {
                            "source": "#main/title_file",
                            "id": "#main/fingerprinting/title_file"
                        },
                        {
                            "source": "#main/waltz_unfiltered_pool_a",
                            "id": "#main/fingerprinting/waltz_directory_A"
                        },
                        {
                            "source": "#main/waltz_duplex_pool_a",
                            "id": "#main/fingerprinting/waltz_directory_A_duplex"
                        },
                        {
                            "source": "#main/waltz_unfiltered_pool_b",
                            "id": "#main/fingerprinting/waltz_directory_B"
                        },
                        {
                            "source": "#main/waltz_duplex_pool_b",
                            "id": "#main/fingerprinting/waltz_directory_B_duplex"
                        }
                    ],
                    "out": [
                        "#main/fingerprinting/all_fp_results",
                        "#main/fingerprinting/FPFigures",
                        "#main/fingerprinting/gender_table",
                        "#main/fingerprinting/gender_plot"
                    ],
                    "id": "#main/fingerprinting"
                },
                {
                    "run": "#group_qc_files.cwl",
                    "in": [
                        {
                            "source": "#main/fingerprinting/all_fp_results",
                            "id": "#main/group_qc_files/all_fp_results"
                        },
                        {
                            "source": "#main/combine_qc/combined_qc",
                            "id": "#main/group_qc_files/combined_qc"
                        },
                        {
                            "source": "#main/duplex_aggregate_bam_metrics_pool_a/output_dir",
                            "id": "#main/group_qc_files/duplex_aggregate_bam_metrics_pool_a"
                        },
                        {
                            "source": "#main/duplex_aggregate_bam_metrics_pool_b/output_dir",
                            "id": "#main/group_qc_files/duplex_aggregate_bam_metrics_pool_b"
                        },
                        {
                            "source": "#main/umi_qc_tables/family_sizes",
                            "id": "#main/group_qc_files/family_sizes"
                        },
                        {
                            "source": "#main/umi_qc_tables/family_types_A",
                            "id": "#main/group_qc_files/family_types_A"
                        },
                        {
                            "source": "#main/umi_qc_tables/family_types_B",
                            "id": "#main/group_qc_files/family_types_B"
                        },
                        {
                            "source": "#main/fingerprinting/gender_table",
                            "id": "#main/group_qc_files/gender_table"
                        },
                        {
                            "source": "#main/noise_tables/noise",
                            "id": "#main/group_qc_files/noise_alt_percent"
                        },
                        {
                            "source": "#main/noise_tables/noise_by_substitution",
                            "id": "#main/group_qc_files/noise_contributing_sites"
                        },
                        {
                            "source": "#main/simplex_aggregate_bam_metrics_pool_a/output_dir",
                            "id": "#main/group_qc_files/simplex_aggregate_bam_metrics_pool_a"
                        },
                        {
                            "source": "#main/simplex_aggregate_bam_metrics_pool_b/output_dir",
                            "id": "#main/group_qc_files/simplex_aggregate_bam_metrics_pool_b"
                        },
                        {
                            "source": "#main/standard_aggregate_bam_metrics_pool_a/output_dir",
                            "id": "#main/group_qc_files/standard_aggregate_bam_metrics_pool_a"
                        },
                        {
                            "source": "#main/standard_aggregate_bam_metrics_pool_b/output_dir",
                            "id": "#main/group_qc_files/standard_aggregate_bam_metrics_pool_b"
                        },
                        {
                            "source": "#main/unfiltered_aggregate_bam_metrics_pool_a/output_dir",
                            "id": "#main/group_qc_files/unfiltered_aggregate_bam_metrics_pool_a"
                        },
                        {
                            "source": "#main/unfiltered_aggregate_bam_metrics_pool_b/output_dir",
                            "id": "#main/group_qc_files/unfiltered_aggregate_bam_metrics_pool_b"
                        }
                    ],
                    "out": [
                        "#main/group_qc_files/qc_files"
                    ],
                    "id": "#main/group_qc_files"
                },
                {
                    "run": "#innovation_qc.cwl",
                    "in": [
                        {
                            "source": "#main/duplex_aggregate_bam_metrics_pool_a/output_dir",
                            "id": "#main/innovation_qc/duplex_waltz_metrics_pool_a"
                        },
                        {
                            "source": "#main/duplex_aggregate_bam_metrics_pool_b/output_dir",
                            "id": "#main/innovation_qc/duplex_waltz_metrics_pool_b"
                        },
                        {
                            "source": "#main/umi_qc_tables/family_sizes",
                            "id": "#main/innovation_qc/family_sizes"
                        },
                        {
                            "source": "#main/umi_qc_tables/family_types_A",
                            "id": "#main/innovation_qc/family_types_A"
                        },
                        {
                            "source": "#main/umi_qc_tables/family_types_B",
                            "id": "#main/innovation_qc/family_types_B"
                        },
                        {
                            "source": "#main/inputs_yaml",
                            "id": "#main/innovation_qc/inputs_yaml"
                        },
                        {
                            "source": "#main/simplex_aggregate_bam_metrics_pool_a/output_dir",
                            "id": "#main/innovation_qc/simplex_waltz_metrics_pool_a"
                        },
                        {
                            "source": "#main/simplex_aggregate_bam_metrics_pool_b/output_dir",
                            "id": "#main/innovation_qc/simplex_waltz_metrics_pool_b"
                        },
                        {
                            "source": "#main/standard_aggregate_bam_metrics_pool_a/output_dir",
                            "id": "#main/innovation_qc/standard_waltz_metrics_pool_a"
                        },
                        {
                            "source": "#main/standard_aggregate_bam_metrics_pool_b/output_dir",
                            "id": "#main/innovation_qc/standard_waltz_metrics_pool_b"
                        },
                        {
                            "source": "#main/title_file",
                            "id": "#main/innovation_qc/title_file"
                        },
                        {
                            "source": "#main/unfiltered_aggregate_bam_metrics_pool_a/output_dir",
                            "id": "#main/innovation_qc/unfiltered_waltz_metrics_pool_a"
                        },
                        {
                            "source": "#main/unfiltered_aggregate_bam_metrics_pool_b/output_dir",
                            "id": "#main/innovation_qc/unfiltered_waltz_metrics_pool_b"
                        }
                    ],
                    "out": [
                        "#main/innovation_qc/read_counts",
                        "#main/innovation_qc/align_rate",
                        "#main/innovation_qc/mean_cov",
                        "#main/innovation_qc/on_target_rate",
                        "#main/innovation_qc/gc_cov_each_sample",
                        "#main/innovation_qc/insert_sizes",
                        "#main/innovation_qc/coverage_per_interval",
                        "#main/innovation_qc/title_page",
                        "#main/innovation_qc/pipeline_inputs",
                        "#main/innovation_qc/family_types",
                        "#main/innovation_qc/family_sizes_all",
                        "#main/innovation_qc/family_sizes_simplex",
                        "#main/innovation_qc/family_sizes_duplex"
                    ],
                    "id": "#main/innovation_qc"
                },
                {
                    "run": "#plot_noise.cwl",
                    "in": [
                        {
                            "source": "#main/noise_tables/noise",
                            "id": "#main/noise_plots/noise"
                        },
                        {
                            "source": "#main/noise_tables/noise_by_substitution",
                            "id": "#main/noise_plots/noise_by_substitution"
                        },
                        {
                            "source": "#main/title_file",
                            "id": "#main/noise_plots/title_file"
                        }
                    ],
                    "out": [
                        "#main/noise_plots/noise_alt_percent",
                        "#main/noise_plots/noise_contributing_sites"
                    ],
                    "id": "#main/noise_plots"
                },
                {
                    "run": "#calculate_noise.cwl",
                    "in": [
                        {
                            "source": "#main/noise__good_positions_A",
                            "id": "#main/noise_tables/good_positions_A"
                        },
                        {
                            "source": "#main/waltz_duplex_pool_a",
                            "id": "#main/noise_tables/waltz_directory"
                        }
                    ],
                    "out": [
                        "#main/noise_tables/noise",
                        "#main/noise_tables/noise_by_substitution"
                    ],
                    "id": "#main/noise_tables"
                },
                {
                    "run": "#aggregate_bam_metrics.cwl",
                    "in": [
                        {
                            "valueFrom": "$('waltz_simplex_pool_a')",
                            "id": "#main/simplex_aggregate_bam_metrics_pool_a/output_dir_name"
                        },
                        {
                            "source": "#main/waltz_simplex_pool_a",
                            "id": "#main/simplex_aggregate_bam_metrics_pool_a/waltz_input_files"
                        }
                    ],
                    "out": [
                        "#main/simplex_aggregate_bam_metrics_pool_a/output_dir"
                    ],
                    "id": "#main/simplex_aggregate_bam_metrics_pool_a"
                },
                {
                    "run": "#aggregate_bam_metrics.cwl",
                    "in": [
                        {
                            "valueFrom": "$('waltz_simplex_pool_b')",
                            "id": "#main/simplex_aggregate_bam_metrics_pool_b/output_dir_name"
                        },
                        {
                            "source": "#main/waltz_simplex_pool_b",
                            "id": "#main/simplex_aggregate_bam_metrics_pool_b/waltz_input_files"
                        }
                    ],
                    "out": [
                        "#main/simplex_aggregate_bam_metrics_pool_b/output_dir"
                    ],
                    "id": "#main/simplex_aggregate_bam_metrics_pool_b"
                },
                {
                    "run": "#aggregate_bam_metrics.cwl",
                    "in": [
                        {
                            "valueFrom": "$('waltz_standard_pool_a')",
                            "id": "#main/standard_aggregate_bam_metrics_pool_a/output_dir_name"
                        },
                        {
                            "source": "#main/waltz_standard_pool_a",
                            "id": "#main/standard_aggregate_bam_metrics_pool_a/waltz_input_files"
                        }
                    ],
                    "out": [
                        "#main/standard_aggregate_bam_metrics_pool_a/output_dir"
                    ],
                    "id": "#main/standard_aggregate_bam_metrics_pool_a"
                },
                {
                    "run": "#aggregate_bam_metrics.cwl",
                    "in": [
                        {
                            "valueFrom": "$('waltz_standard_pool_b')",
                            "id": "#main/standard_aggregate_bam_metrics_pool_b/output_dir_name"
                        },
                        {
                            "source": "#main/waltz_standard_pool_b",
                            "id": "#main/standard_aggregate_bam_metrics_pool_b/waltz_input_files"
                        }
                    ],
                    "out": [
                        "#main/standard_aggregate_bam_metrics_pool_b/output_dir"
                    ],
                    "id": "#main/standard_aggregate_bam_metrics_pool_b"
                },
                {
                    "run": "#make_umi_qc_tables.cwl",
                    "in": [
                        {
                            "source": "#main/A_on_target_positions",
                            "id": "#main/umi_qc_tables/A_on_target_positions"
                        },
                        {
                            "source": "#main/B_on_target_positions",
                            "id": "#main/umi_qc_tables/B_on_target_positions"
                        },
                        {
                            "source": "#main/sample_directories",
                            "id": "#main/umi_qc_tables/folders"
                        }
                    ],
                    "out": [
                        "#main/umi_qc_tables/family_sizes",
                        "#main/umi_qc_tables/family_types_A",
                        "#main/umi_qc_tables/family_types_B"
                    ],
                    "id": "#main/umi_qc_tables"
                },
                {
                    "run": "#aggregate_bam_metrics.cwl",
                    "in": [
                        {
                            "valueFrom": "$('waltz_unfiltered_pool_a')",
                            "id": "#main/unfiltered_aggregate_bam_metrics_pool_a/output_dir_name"
                        },
                        {
                            "source": "#main/waltz_unfiltered_pool_a",
                            "id": "#main/unfiltered_aggregate_bam_metrics_pool_a/waltz_input_files"
                        }
                    ],
                    "out": [
                        "#main/unfiltered_aggregate_bam_metrics_pool_a/output_dir"
                    ],
                    "id": "#main/unfiltered_aggregate_bam_metrics_pool_a"
                },
                {
                    "run": "#aggregate_bam_metrics.cwl",
                    "in": [
                        {
                            "valueFrom": "$('waltz_unfiltered_pool_b')",
                            "id": "#main/unfiltered_aggregate_bam_metrics_pool_b/output_dir_name"
                        },
                        {
                            "source": "#main/waltz_unfiltered_pool_b",
                            "id": "#main/unfiltered_aggregate_bam_metrics_pool_b/waltz_input_files"
                        }
                    ],
                    "out": [
                        "#main/unfiltered_aggregate_bam_metrics_pool_b/output_dir"
                    ],
                    "id": "#main/unfiltered_aggregate_bam_metrics_pool_b"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
